#include	<stdio.h>
#include	<stdlib.h>
#include	"mach_inject_bundle.h"

char*	descriptionForError(mach_error_t err);

/*	The injection code with error messages is from the PlugSuit project.
	I would have used it directly, if only the dock would post notifications
	when it launches..
	
	-daniel
	
	URL: http://millenomi.altervista.org/PlugSuit/
*/
int	main(int argc, char *argv[]) {
	mach_error_t	err;
	if (argc < 3) {
		printf("Usage: %s <bundle-path> <dock-pid>\n", argv[0]);
		return 1;
	}
	if (atoi(argv[2]) <= 0) {
		printf("Invalid process ID\n");
		return 1;
	}
	err	= mach_inject_bundle_pid(argv[1], atoi(argv[2]));
	if (err) {
		printf("Could not inject the support code in application with error code %d (%s).", err, descriptionForError(err));
		return 1;
	}
	return 0;
}


char*	descriptionForError(mach_error_t err) {   
    switch (err) {
        case err_mach_inject_bundle_couldnt_find_injection_bundle:
            return "The injection bundle cannot be found";
        case err_mach_inject_bundle_couldnt_find_inject_entry_symbol:
            return "The entry symbol in the injection bundle cannot be found";
        case err_mach_inject_bundle_couldnt_load_framework_bundle:
            return "The framework bundle cannot be loaded";
        case err_mach_inject_bundle_couldnt_load_injection_bundle:
            return "The injection bundle cannot be loaded";
		case 5:
			return "Spaces Spaces Spaces was blocked by OS X's security.";
        default:
            return "I don't know what kind of error it is.";
    }
}
